diff --git a/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXParadise.java b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXParadise.java
new file mode 100644
index 000000000..d43b8b23d
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXParadise.java
@@ -0,0 +1,61 @@
+package net.minecraft.client.render.worldtype;
+
+import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.type.WorldType;
+
+public class WorldTypeFXParadise extends WorldTypeFX{
+    public WorldTypeFXParadise(WorldType worldType) {
+        super(worldType);
+    }
+
+    @Override
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+        float[] sunriseCol = new float[4];
+        float f2 = 0.4F;
+        float f3 = MathHelper.cos(timeOfDay * MathHelper.PI * 2.0F) - 0.0F;
+        float f4 = -0F;
+        if (f3 >= f4 - f2 && f3 <= f4 + f2) {
+            float c = ((f3 - f4) / f2) * 0.5F + 0.5F;
+            float a = 1.0F - (1.0F - MathHelper.sin(c * MathHelper.PI)) * 0.99F;
+            a *= a;
+            sunriseCol[0] = c * 0.3F + 0.7F;
+            sunriseCol[1] = c * c * 0.7F + 0.2F;
+            sunriseCol[2] = c * c * 0.0F + 0.2F;
+            sunriseCol[3] = a;
+            return sunriseCol;
+        } else {
+            return null;
+        }
+    }
+
+    @Override
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        float f2 = MathHelper.cos(celestialAngle * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
+        f2 = MathHelper.clamp(f2, 0.0f, 1.0f);
+        float r, g, b;
+
+        if (Colorizers.fog.isEnabled()) {
+            int x1 = MathHelper.floor(x);
+            int y1 = MathHelper.floor(y);
+            int z1 = MathHelper.floor(z);
+
+            int color = Colorizers.fog.getColor(world, x1, y1, z1);
+
+            r = ((color >> 16) & 0xFF) / 255.0f;
+            g = ((color >> 8) & 0xFF) / 255.0f;
+            b = (color & 0xFF) / 255.0f;
+        } else {
+            int i = 0x8080a0;
+            r = (float) (i >> 16 & 0xff) / 255.0f;
+            g = (float) (i >> 8 & 0xff) / 255.0f;
+            b = (float) (i & 0xff) / 255.0f;
+        }
+        r *= f2 * 0.94F + 0.06F;
+        g *= f2 * 0.94F + 0.06F;
+        b *= f2 * 0.91F + 0.09F;
+        return Vec3.getTempVec3(r, g, b);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java b/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
index 3e72839e8..2f04494d5 100644
--- a/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
+++ b/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
@@ -48,6 +48,13 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
         File outRoot = new File(SoundRepository.mc.getMinecraftDir(), String.format(TEXTURE_PACK_FOLDER_SOUNDS_LOCATION_FORMAT, namespace));
         outRoot.mkdirs();
         for (Map.Entry<String, SoundEvent> e : eventMap.entrySet()) {
+
+            if (namespace.equals("minecraft")) {
+                SoundRepository.allKeys.add(e.getKey());
+            } else {
+                SoundRepository.allKeys.add(namespace + ":" + e.getKey());
+            }
+
             register(e.getKey(), e.getValue());
             for (SoundEntry entry : e.getValue().getEntryBag().getEntries()) {
                 if (entry.type == SoundEntry.Type.FILE && entry.file != null && !entry.file.exists()) {
diff --git a/src/main/java/net/minecraft/client/sound/SoundRepository.java b/src/main/java/net/minecraft/client/sound/SoundRepository.java
index 31061d450..0b78e845b 100644
--- a/src/main/java/net/minecraft/client/sound/SoundRepository.java
+++ b/src/main/java/net/minecraft/client/sound/SoundRepository.java
@@ -11,8 +11,12 @@ import java.util.*;
 public class SoundRepository extends Registry<NamedSoundRepository> {
     protected static Minecraft mc = null;
     public static SoundRepository SOUNDS = null;
+
+    public static final Set<String> allKeys = new HashSet<>();
+
     public Set<String> cachedRepositoryErrors = new HashSet<>();
     public Set<NamespaceID> cachedEntryErrors = new HashSet<>();
+
     public SoundRepository() {
         registerNamespace("minecraft");
     }
@@ -80,6 +84,10 @@ public class SoundRepository extends Registry<NamedSoundRepository> {
         return eventList;
     }
 
+    public Collection<String> getAllKeys() {
+        return allKeys;
+    }
+
     private NamespaceID makeNamespaceFromKey(@NotNull String key) {
         String namespace;
         String value;
@@ -104,6 +112,7 @@ public class SoundRepository extends Registry<NamedSoundRepository> {
     }
 
     public static void reload() {
+        allKeys.clear();
         SOUNDS = new SoundRepository();
     }
 
diff --git a/src/main/java/net/minecraft/client/util/debug/DebugRender.java b/src/main/java/net/minecraft/client/util/debug/DebugRender.java
index 05bdbb1ba..8d30c2b04 100644
--- a/src/main/java/net/minecraft/client/util/debug/DebugRender.java
+++ b/src/main/java/net/minecraft/client/util/debug/DebugRender.java
@@ -2,13 +2,14 @@ package net.minecraft.client.util.debug;
 
 import static org.lwjgl.opengl.GL11.*;
 
+import net.minecraft.core.util.debug.Debug;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.Display;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.util.debug.Debug.Profiler;
+import net.minecraft.core.util.debug.Debug.Profiler;
 import net.minecraft.core.util.helper.MathHelper;
 
 public class DebugRender {
diff --git a/src/main/java/net/minecraft/client/world/WorldClient.java b/src/main/java/net/minecraft/client/world/WorldClient.java
index 6ebf4e6f4..39037d115 100644
--- a/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -1,299 +1,154 @@
 package net.minecraft.client.world;
 
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.net.handler.PacketHandlerClient;
-import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
-import net.minecraft.core.data.gamerule.GameRules;
-import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.packet.DisconnectPacket;
-import net.minecraft.core.util.collection.IntHashMap;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.client.render.worldtype.WorldTypeFX;
+import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
+import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
+import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.AuroraProvider;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.chunk.ChunkCoordinates;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.core.world.save.SaveHandlerClientMP;
-
-import java.util.HashSet;
-import java.util.LinkedList;
-import java.util.Set;
-
-// Referenced classes of package net.minecraft.src:
-//            World, SaveHandlerMP, WorldProvider, MCHash, 
-//            ChunkCoordinates, PacketHandlerClient, IWorldAccess, Entity,
-//            WorldBlockPositionType, ChunkProviderClient, DisconnectPacket, WorldInfo,
-//            IChunkProvider
+import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.save.LevelStorage;
+import net.minecraft.core.world.season.SeasonManager;
+import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypes;
+import net.minecraft.core.world.weather.WeatherManager;
 
 public class WorldClient extends World {
-    private final Minecraft mc;
-    private final LinkedList<WorldBlockPositionType> positionTypesList;
-    private final PacketHandlerClient sendQueue;
-    private ChunkProviderClient chunkCache;
-    private final IntHashMap<Entity> entitiesById;
-    private final Set<Entity> forced;
-    private final Set<Entity> reEntries;
-
-    public WorldClient(Minecraft minecraft, PacketHandlerClient netclienthandler, long seed, int dimensionId, int worldTypeId)
-    {
-        super(new SaveHandlerClientMP(), "MpServer", Dimension.getDimensionList().get(dimensionId), Registries.WORLD_TYPES.getItemByNumericId(worldTypeId), seed);
-        this.mc = minecraft;
-        positionTypesList = new LinkedList<>();
-        entitiesById = new IntHashMap<>();
-        forced = new HashSet<>();
-        reEntries = new HashSet<>();
-        sendQueue = netclienthandler;
-        setSpawnPoint(new ChunkCoordinates(8, 64, 8));
-        savedDataStorage = netclienthandler.savedDataStorage;
-    }
-
-    @Override
-	public void tick()
-    {
-        for(int k = 0; k < 10 && !reEntries.isEmpty(); k++)
-        {
-            Entity entity = reEntries.iterator().next();
-            if(!loadedEntityList.contains(entity))
-            {
-                entityJoinedWorld(entity);
-            }
-        }
 
-        processPackets();
-        for(int l = 0; l < positionTypesList.size(); l++)
-        {
-            WorldBlockPositionType worldblockpositiontype = positionTypesList.get(l);
-            if(--worldblockpositiontype.delayTicks == 0)
-            {
-                super.setBlockAndMetadata(worldblockpositiontype.x, worldblockpositiontype.y, worldblockpositiontype.z, worldblockpositiontype.blockId, worldblockpositiontype.metadata);
-                super.markBlockNeedsUpdate(worldblockpositiontype.x, worldblockpositiontype.y, worldblockpositiontype.z);
-                positionTypesList.remove(l--);
-            }
-        }
-        if(getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
-            levelData.setWorldTime(levelData.getWorldTime() + 1L);
-        }
-		updateSeasonAndLight();
-        if(rainbowTicks > 0)
-        {
-            rainbowTicks--;
-        }
-    }
-
-    public void processPackets() {
-        sendQueue.tick();
+    public WorldClient(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType) {
+        super(saveHandler, name, seed, dimension, worldType);
     }
 
-    public void removePositionTypesInBounds(int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
-    {
-        for(int i = 0; i < positionTypesList.size(); i++)
-        {
-            WorldBlockPositionType worldblockpositiontype = positionTypesList.get(i);
-            if(worldblockpositiontype.x >= minX && worldblockpositiontype.y >= minY && worldblockpositiontype.z >= minZ && worldblockpositiontype.x <= maxX && worldblockpositiontype.y <= maxY && worldblockpositiontype.z <= maxZ)
-            {
-                positionTypesList.remove(i--);
-            }
-        }
-
+    public WorldClient(World world, Dimension dimension) {
+        super(world, dimension);
     }
 
-    @Override
-	protected IChunkProvider createChunkProvider()
-    {
-        chunkCache = new ChunkProviderClient(this);
-        return chunkCache;
+    public WorldClient(LevelStorage saveHandler, String name, Dimension dimension, WorldType worldType, long seed) {
+        super(saveHandler, name, dimension, worldType, seed);
     }
 
-    @Override
-	public void getRespawnLocation()
-    {
-        setSpawnPoint(new ChunkCoordinates(8, 64, 8));
-    }
+    public WorldClient() {
+        this.dimension = Dimension.OVERWORLD;
+        this.saveHandler = null;
+        levelData = new LevelData(0, "modelviewer");
+        this.worldType = WorldTypes.DEBUG;
+        chunkProvider = new ChunkProviderViewer(this);
+        seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
+        updateSkyBrightness();
 
-    @Override
-	protected void updateBlocksAndPlayCaveSounds()
-    {
-    }
+        this.weatherManager = new WeatherManager(this);
 
-    @Override
-	public void scheduleBlockUpdate(int x, int y, int z, int id, int delay)
-    {
-    }
+        auroraProvider = new AuroraProvider(this, 0);
 
-    @Override
-	public boolean tickUpdates(boolean all)
-    {
-        return false;
+        biomeProvider = this.worldType.createBiomeProvider(this);
     }
 
-    public void doPreChunk(int chunkX, int chunkZ, boolean playerAdded)
+    public Vec3 getDimensionColor(ICamera camera, float partialTick)
     {
-        if(playerAdded)
-        {
-            chunkCache.prepareChunk(chunkX, chunkZ);
-        } else
+        float f1 = getCelestialAngle(partialTick);
+        float f2 = MathHelper.cos(f1 * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
+        if(f2 < 0.0F)
         {
-            chunkCache.dropChunk(chunkX, chunkZ);
+            f2 = 0.0F;
         }
-        if(!playerAdded)
+        if(f2 > 1.0F)
         {
-            markBlocksDirty(chunkX * 16, 0, chunkZ * 16, chunkX * 16 + 15, getHeightBlocks(), chunkZ * 16 + 15);
+            f2 = 1.0F;
         }
-    }
-
-    @Override
-	public boolean entityJoinedWorld(Entity entity)
-    {
-        boolean flag = super.entityJoinedWorld(entity);
-        forced.add(entity);
-        if(!flag)
+        int color = 0xffffff;
+        float r = (float)(color >> 16 & 255) / 255F;
+        float g = (float)(color >> 8 & 255) / 255F;
+        float b = (float)(color & 255) / 255F;
+        float f6 = getCurrentWeather() != null && getCurrentWeather().isPrecipitation ? weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower() : 0.0f;
+        if(f6 > 0.0F)
         {
-            reEntries.add(entity);
+            float f7 = (r * 0.3F + g * 0.59F + b * 0.11F) * 0.6F;
+            float f9 = 1.0F - f6 * 0.95F;
+            r = r * f9 + f7 * (1.0F - f9);
+            g = g * f9 + f7 * (1.0F - f9);
+            b = b * f9 + f7 * (1.0F - f9);
         }
-        return flag;
+        r *= f2 * 0.9F + 0.1F;
+        g *= f2 * 0.9F + 0.1F;
+        b *= f2 * 0.85F + 0.15F;
+        return Vec3.getTempVec3(r, g, b);
     }
 
-    @Override
-	public void setEntityDead(Entity entity)
+    public Vec3 getFogColor(ICamera camera, float partialTick)
     {
-        super.setEntityDead(entity);
-        forced.remove(entity);
-        reEntries.remove(entity);
+        double x = camera.getX(partialTick);
+        double y = camera.getY(partialTick);
+        double z = camera.getZ(partialTick);
+        float celestialAngle = getCelestialAngle(partialTick);
+        return WorldTypeFXDispatcher.getInstance().getDispatch(worldType).getFogColor(this, x, y, z, celestialAngle, partialTick);
     }
 
-    @Override
-	protected void obtainEntitySkin(Entity entity)
+    public Vec3 getSkyColor(ICamera camera, float partialTick)
     {
-        super.obtainEntitySkin(entity);
-        reEntries.remove(entity);
-    }
-
-    @Override
-	protected void releaseEntitySkin(Entity entity)
-    {
-        super.releaseEntitySkin(entity);
-        if(forced.contains(entity))
-        {
-            reEntries.add(entity);
-        }
-    }
-
-    public void addEntityToWorld(int i, Entity entity)
-    {
-        Entity entity1 = getEntityFromId(i);
-        if(entity1 != null)
+        float f1 = getCelestialAngle(partialTick);
+        float f2 = MathHelper.cos(f1 * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
+        if(f2 < 0.0F)
         {
-            setEntityDead(entity1);
+            f2 = 0.0F;
         }
-        forced.add(entity);
-        entity.id = i;
-        if(!entityJoinedWorld(entity))
+        if(f2 > 1.0F)
         {
-            reEntries.add(entity);
+            f2 = 1.0F;
         }
-        entitiesById.put(i, entity);
-    }
-
-    public Entity getEntityFromId(int i)
-    {
-        return entitiesById.get(i);
-    }
+        int x = MathHelper.floor(camera.getX(partialTick));
+        int y = MathHelper.floor(camera.getY(partialTick));
+        int z = MathHelper.floor(camera.getZ(partialTick));
+        float blockTemperature = (float) getBlockTemperature(x, z);
 
-    public Entity removeEntityFromWorld(int i)
-    {
-        Entity entity = entitiesById.remove(i);
-        if(entity != null)
+        if (seasonManager.getCurrentSeason() != null && (seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER || seasonManager.getCurrentSeason() == Seasons.OVERWORLD_FALL))
         {
-            forced.remove(entity);
-            setEntityDead(entity);
+            blockTemperature = blockTemperature - (1.25f);
         }
-        return entity;
-    }
-
-    @Override
-	public boolean setBlockMetadata(int x, int y, int z, int meta)
-    {
-        int blockID = getBlockId(x, y, z);
-        int currentMeta = getBlockMetadata(x, y, z);
-        if(super.setBlockMetadata(x, y, z, meta))
-        {
-            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockID, currentMeta));
-            return true;
-        } else
-        {
-            return false;
+        int skyColor;
+        if(Colorizers.sky.isEnabled()) {
+            skyColor = Colorizers.sky.getColor(this, x, y, z);
+        }else {
+            skyColor = getBiomeProvider().getBiome(x, y, z).getSkyColor(blockTemperature);
         }
-    }
-
-    @Override
-	public boolean setBlockAndMetadata(int x, int y, int z, int id, int meta)
-    {
-        int blockId = getBlockId(x, y, z);
-        int blockMeta = getBlockMetadata(x, y, z);
-        if(super.setBlockAndMetadata(x, y, z, id, meta))
-        {
-            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockId, blockMeta));
-            return true;
-        } else
+        float r = (float)(skyColor >> 16 & 0xff) / 255F;
+        float g = (float)(skyColor >> 8 & 0xff) / 255F;
+        float b = (float)(skyColor & 0xff) / 255F;
+        r *= f2;
+        g *= f2;
+        b *= f2;
+        float f7 = getCurrentWeather() != null && getCurrentWeather().isPrecipitation ? weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower() : 0.0f;
+        if(f7 > 0.0F)
         {
-            return false;
+            float f8 = (r * 0.3F + g * 0.59F + b * 0.11F) * 0.6F;
+            float f10 = 1.0F - f7 * 0.75F;
+            r = r * f10 + f8 * (1.0F - f10);
+            g = g * f10 + f8 * (1.0F - f10);
+            b = b * f10 + f8 * (1.0F - f10);
         }
-    }
-
-    @Override
-	public boolean setBlock(int x, int y, int z, int id)
-    {
-        int blockId = getBlockId(x, y, z);
-        int meta = getBlockMetadata(x, y, z);
-        if(super.setBlock(x, y, z, id))
-        {
-            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockId, meta));
-            return true;
-        } else
-        {
-            return false;
-        }
-    }
-
-    public boolean blockChange(int x, int y, int z, int id, int meta)
-    {
-        removePositionTypesInBounds(x, y, z, x, y, z);
-        if(super.setBlockAndMetadata(x, y, z, id, meta))
-        {
-            notifyBlockChange(x, y, z, id);
-            return true;
-        } else
+        if(lightningFlicker > 0)
         {
-            return false;
+            float f12 = (float)lightningFlicker - partialTick;
+            if(f12 > 1.0F)
+            {
+                f12 = 1.0F;
+            }
+            f12 *= 0.45F;
+            r = r * (1.0F - f12) + 0.8F * f12;
+            g = g * (1.0F - f12) + 0.8F * f12;
+            b = b * (1.0F - f12) + f12;
         }
+        return Vec3.getTempVec3(r, g, b);
     }
 
     @Override
-	public void sendQuittingDisconnectingPacket()
-    {
-        sendQueue.sendFinalPacket(new DisconnectPacket("Quitting"));
-    }
-
-    @Override
-    public void sendGlobalMessage(String message){
-
-    }
-
-    static class WorldBlockPositionType
-    {
-        int x;
-        int y;
-        int z;
-        int delayTicks;
-        int blockId;
-        int metadata;
-
-        public WorldBlockPositionType(int x, int y, int z, int blockId, int metadata) {
-            this.x = x;
-            this.y = y;
-            this.z = z;
-            this.delayTicks = 80;
-            this.blockId = blockId;
-            this.metadata = metadata;
-        }
+    public int getLightmapCoord(int skylight, int blocklight) {
+        return LightmapHelper.getLightmapCoord(skylight, blocklight);
     }
 }
diff --git a/src/main/java/net/minecraft/client/world/WorldClientMP.java b/src/main/java/net/minecraft/client/world/WorldClientMP.java
new file mode 100644
index 000000000..98c03d6e3
--- /dev/null
+++ b/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -0,0 +1,289 @@
+package net.minecraft.client.world;
+
+import net.minecraft.client.net.handler.PacketHandlerClient;
+import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
+import net.minecraft.core.data.gamerule.GameRules;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.net.packet.DisconnectPacket;
+import net.minecraft.core.util.collection.IntHashMap;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.chunk.ChunkCoordinates;
+import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.client.world.save.SaveHandlerClientMP;
+
+import java.util.HashSet;
+import java.util.LinkedList;
+import java.util.Set;
+
+public class WorldClientMP extends WorldClient {
+    private final LinkedList<WorldBlockPositionType> positionTypesList;
+    private final PacketHandlerClient sendQueue;
+    private ChunkProviderClient chunkCache;
+    private final IntHashMap<Entity> entitiesById;
+    private final Set<Entity> forced;
+    private final Set<Entity> reEntries;
+
+    public WorldClientMP(PacketHandlerClient packetHandlerClient, long seed, int dimensionId, int worldTypeId)
+    {
+        super(new SaveHandlerClientMP(), "MpServer", Dimension.getDimensionList().get(dimensionId), Registries.WORLD_TYPES.getItemByNumericId(worldTypeId), seed);
+        positionTypesList = new LinkedList<>();
+        entitiesById = new IntHashMap<>();
+        forced = new HashSet<>();
+        reEntries = new HashSet<>();
+        sendQueue = packetHandlerClient;
+        setSpawnPoint(new ChunkCoordinates(8, 64, 8));
+        savedDataStorage = packetHandlerClient.savedDataStorage;
+    }
+
+    @Override
+	public void tick()
+    {
+        for(int k = 0; k < 10 && !reEntries.isEmpty(); k++)
+        {
+            Entity entity = reEntries.iterator().next();
+            if(!loadedEntityList.contains(entity))
+            {
+                entityJoinedWorld(entity);
+            }
+        }
+
+        processPackets();
+        for(int l = 0; l < positionTypesList.size(); l++)
+        {
+            WorldBlockPositionType worldblockpositiontype = positionTypesList.get(l);
+            if(--worldblockpositiontype.delayTicks == 0)
+            {
+                super.setBlockAndMetadata(worldblockpositiontype.x, worldblockpositiontype.y, worldblockpositiontype.z, worldblockpositiontype.blockId, worldblockpositiontype.metadata);
+                super.markBlockNeedsUpdate(worldblockpositiontype.x, worldblockpositiontype.y, worldblockpositiontype.z);
+                positionTypesList.remove(l--);
+            }
+        }
+        if(getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
+            levelData.setWorldTime(levelData.getWorldTime() + 1L);
+        }
+		updateSeasonAndLight();
+        if(rainbowTicks > 0)
+        {
+            rainbowTicks--;
+        }
+    }
+
+    public void processPackets() {
+        sendQueue.tick();
+    }
+
+    public void removePositionTypesInBounds(int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
+    {
+        for(int i = 0; i < positionTypesList.size(); i++)
+        {
+            WorldBlockPositionType worldblockpositiontype = positionTypesList.get(i);
+            if(worldblockpositiontype.x >= minX && worldblockpositiontype.y >= minY && worldblockpositiontype.z >= minZ && worldblockpositiontype.x <= maxX && worldblockpositiontype.y <= maxY && worldblockpositiontype.z <= maxZ)
+            {
+                positionTypesList.remove(i--);
+            }
+        }
+
+    }
+
+    @Override
+	protected IChunkProvider createChunkProvider()
+    {
+        chunkCache = new ChunkProviderClient(this);
+        return chunkCache;
+    }
+
+    @Override
+	public void getRespawnLocation()
+    {
+        setSpawnPoint(new ChunkCoordinates(8, 64, 8));
+    }
+
+    @Override
+	protected void updateBlocksAndPlayCaveSounds()
+    {
+    }
+
+    @Override
+	public void scheduleBlockUpdate(int x, int y, int z, int id, int delay)
+    {
+    }
+
+    @Override
+	public boolean tickUpdates(boolean all)
+    {
+        return false;
+    }
+
+    public void doPreChunk(int chunkX, int chunkZ, boolean playerAdded)
+    {
+        if(playerAdded)
+        {
+            chunkCache.prepareChunk(chunkX, chunkZ);
+        } else
+        {
+            chunkCache.dropChunk(chunkX, chunkZ);
+        }
+        if(!playerAdded)
+        {
+            markBlocksDirty(chunkX * 16, 0, chunkZ * 16, chunkX * 16 + 15, getHeightBlocks(), chunkZ * 16 + 15);
+        }
+    }
+
+    @Override
+	public boolean entityJoinedWorld(Entity entity)
+    {
+        boolean flag = super.entityJoinedWorld(entity);
+        forced.add(entity);
+        if(!flag)
+        {
+            reEntries.add(entity);
+        }
+        return flag;
+    }
+
+    @Override
+	public void setEntityDead(Entity entity)
+    {
+        super.setEntityDead(entity);
+        forced.remove(entity);
+        reEntries.remove(entity);
+    }
+
+    @Override
+	protected void obtainEntitySkin(Entity entity)
+    {
+        super.obtainEntitySkin(entity);
+        reEntries.remove(entity);
+    }
+
+    @Override
+	protected void releaseEntitySkin(Entity entity)
+    {
+        super.releaseEntitySkin(entity);
+        if(forced.contains(entity))
+        {
+            reEntries.add(entity);
+        }
+    }
+
+    public void addEntityToWorld(int i, Entity entity)
+    {
+        Entity entity1 = getEntityFromId(i);
+        if(entity1 != null)
+        {
+            setEntityDead(entity1);
+        }
+        forced.add(entity);
+        entity.id = i;
+        if(!entityJoinedWorld(entity))
+        {
+            reEntries.add(entity);
+        }
+        entitiesById.put(i, entity);
+    }
+
+    public Entity getEntityFromId(int i)
+    {
+        return entitiesById.get(i);
+    }
+
+    public Entity removeEntityFromWorld(int i)
+    {
+        Entity entity = entitiesById.remove(i);
+        if(entity != null)
+        {
+            forced.remove(entity);
+            setEntityDead(entity);
+        }
+        return entity;
+    }
+
+    @Override
+	public boolean setBlockMetadata(int x, int y, int z, int meta)
+    {
+        int blockID = getBlockId(x, y, z);
+        int currentMeta = getBlockMetadata(x, y, z);
+        if(super.setBlockMetadata(x, y, z, meta))
+        {
+            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockID, currentMeta));
+            return true;
+        } else
+        {
+            return false;
+        }
+    }
+
+    @Override
+	public boolean setBlockAndMetadata(int x, int y, int z, int id, int meta)
+    {
+        int blockId = getBlockId(x, y, z);
+        int blockMeta = getBlockMetadata(x, y, z);
+        if(super.setBlockAndMetadata(x, y, z, id, meta))
+        {
+            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockId, blockMeta));
+            return true;
+        } else
+        {
+            return false;
+        }
+    }
+
+    @Override
+	public boolean setBlock(int x, int y, int z, int id)
+    {
+        int blockId = getBlockId(x, y, z);
+        int meta = getBlockMetadata(x, y, z);
+        if(super.setBlock(x, y, z, id))
+        {
+            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockId, meta));
+            return true;
+        } else
+        {
+            return false;
+        }
+    }
+
+    public boolean blockChange(int x, int y, int z, int id, int meta)
+    {
+        removePositionTypesInBounds(x, y, z, x, y, z);
+        if(super.setBlockAndMetadata(x, y, z, id, meta))
+        {
+            notifyBlockChange(x, y, z, id);
+            return true;
+        } else
+        {
+            return false;
+        }
+    }
+
+    @Override
+	public void sendQuittingDisconnectingPacket()
+    {
+        sendQueue.sendFinalPacket(new DisconnectPacket("Quitting"));
+    }
+
+    @Override
+    public void sendGlobalMessage(String message){
+
+    }
+
+    static class WorldBlockPositionType
+    {
+        int x;
+        int y;
+        int z;
+        int delayTicks;
+        int blockId;
+        int metadata;
+
+        public WorldBlockPositionType(int x, int y, int z, int blockId, int metadata) {
+            this.x = x;
+            this.y = y;
+            this.z = z;
+            this.delayTicks = 80;
+            this.blockId = blockId;
+            this.metadata = metadata;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/save/SaveHandlerClientMP.java b/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
similarity index 85%
rename from src/main/java/net/minecraft/core/world/save/SaveHandlerClientMP.java
rename to src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
index cc5a3778c..38a3d9e87 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveHandlerClientMP.java
+++ b/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
@@ -1,9 +1,13 @@
-package net.minecraft.core.world.save;
+package net.minecraft.client.world.save;
 
 import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.DimensionData;
+import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.save.LevelStorage;
+import net.minecraft.core.world.save.PlayerIO;
 
 import java.io.File;
 import java.util.List;
diff --git a/src/main/java/net/minecraft/core/world/save/SaveHandlerClientSP.java b/src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java
similarity index 83%
rename from src/main/java/net/minecraft/core/world/save/SaveHandlerClientSP.java
rename to src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java
index b345ef62e..05a1d79ab 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveHandlerClientSP.java
+++ b/src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java
@@ -1,9 +1,12 @@
-package net.minecraft.core.world.save;
+package net.minecraft.client.world.save;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.chunk.ChunkLoaderRegionAsync;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.ISaveFormat;
+import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.save.SaveHandlerBase;
 
 import java.io.File;
 import java.util.List;
